//============================================================
//  TARGET SYSTEM : *
//  FUNCTION      : ϒz񑀍pCu
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================
#ifndef     __VL_ARRAY_H__
#define     __VL_ARRAY_H__

#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>

#define     VL_ARRAY_DEBUG


#define     VL_ARRAY_OK   (0)
#define     VL_ARRAY_NG   (-1)

#define     VL_ARRAY_CHECK
#define     VL_ARRAY_UNIT_OF_INDEX    (1024)

//----- Xg̊ǗubN ------------------------------------------
struct VLArray_t{
    int                         NumOfMember;    // XgɂԂ牺o
    void                        **ObjIndex;        // Xg̃CfbNX\BXgQƂ̍ɎgB
    int                         ObjIndexSize;      // Xg̃CfbNX\̃TCY
    int                         (*Remove)(void *Object);
                                                // *(VLArrayMember.Object)free֐ւ̊֐|C^(VL_ARRAY_OKAsBYDIR_LIST_NGԂ)
                                                // *(VLArrayMember.Object)XgAꖇ̃f[^\łȂŁAgIƉȂΕKvB
                                                // svȂVLArrayCreate()̑PNULLƂăXg΂悢B
    int                         (*Find)(void *Object, void *Key); // VLArrayMember֐ւ̊֐|C^
                                                // ̊֐́APosition->Object̓eKeyŎw肵L[ƈvVL_ARRAY_OKAvȂVL_ARRAY_OKȊOԂKv
                                                // XǧsvȂVLArrayCreate()̑QNULLƂăXg΂悢
                                                // ̏ꍇVLArrayMemberFind()͏BYDIR_LIST_NGԂ
                                                //  ORemoveA͎̎׈ȊB܂qsort()̗邵A{lgȂ낤OKƂ
                                                // Ȃ݂ɁAꍇɂČL[g
                                                // struct hoge_t{
                                                //      int     KeyType;
                                                //      void    *TrueKey;
                                                // } hoge;
                                                // `āAFind֐KeyœnAŒ`Find֐KeyTypeŌL[w肷΂悢͂B
};
typedef struct VLArray_t VLArray;


//----- ֐ ------------------------------------------
//====================================================================================================================
VLArray *VLArrayCreate(int (*Remove)(void *Object), int (*Find)(void *Object, void *Key));
//====================================================================================================================
// [@\] ϒzǗubN쐬
// [] ϒzɊi[Objectfree֐ւ̃|C^BwȂ̏ꍇNULLł悢
// [] ϒzɊi[ObjectKeygČ֐ւ̃|C^BwȂ̏ꍇNULLł悢
// [Ԓl] sNULLAAVLArrayւ̃|C^ԂB

//====================================================================================================================
int VLArrayRemove(VLArray *VLA);
//====================================================================================================================
// [@\] ϒz̊ǗubN݂̂폜
// [] VLArray *VLA     Fϒz
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB

//====================================================================================================================
int VLArrayRemoveAll(VLArray *VLA);
//====================================================================================================================
// [@\] ϒzŜ폜
// [] VLArray *VLA     F폜Ώۂ̉ϒz
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB

//====================================================================================================================
void  *VLArrayMemberAdd(VLArray *VLA,  void *Object, int ObjectSize);
//====================================================================================================================
// [@\] ϒz̍ŌɃoǉ(*Object̓Rs[ÃRs[ϒzɂԂ牺)
// [] VLArray *VLA     Fϒz
// [] void      *Object FǉIuWFNgւ̃|C^
// [] void      *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sNULLAAǉoւ̃|C^Ԃ

//====================================================================================================================
int VLArrayMemberRemove(VLArray *VLA,  int Position);
//====================================================================================================================
// [@\] ϒz񂩂PositonԖڂ̃o폜 (㑱̃o͑Ol)
// [] VLArray *VLA     Fϒz
// [] int       PositionF폜郁öʒu
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB

//====================================================================================================================
int VLArrayMemberInsertPrev(VLArray *VLA,  int Position, void *Object, int ObjectSize);
//====================================================================================================================
// [@\] ϒz񒆂Positon̑OɃoǉ(*Object̓Rs[A
//        ̃Rs[ϒzɑ})
//        Ⴆ΁APosition5ȂAVKǉꂽo5ԖڂɂȂāA
//        ܂5Ԗڂo6ԖڂɂȂB
//        ϒz񂪋Ȃ΁A擪ɒǉ
// [] VLArray        *VLA         F*Objectǉϒz
// [] int              Position    FIuWFNgǉʒu
// [] void             *Object     FǉIuWFNgւ̃|C^
// [] void             *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB

//====================================================================================================================
int VLArrayMemberInsertNext(VLArray *VLA,  int Position, void *Object, int ObjectSize);
//====================================================================================================================
// [@\] ϒz񒆂PositoňɃoǉ(*Object̓Rs[A
//        ̃Rs[VLArrayMember.ObjectɉϒzɂԂ牺)
//        Ⴆ΁APosition5ȂAVKǉꂽo6ԖڂɂȂāA
//        ܂5Ԗڂo5Ԗڂ̂܂܂ɂȂB
//        ϒz񂪋Ȃ΁A擪ɒǉ
// [] VLArray        *VLA         F*Objectǉϒz
// [] VLArrayMember  *Position   FIuWFNgǉʒu
// [] void             *Object     FǉIuWFNgւ̃|C^
// [] void             *ObjectSize FǉIuWFNg̃TCY
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB

//====================================================================================================================
void *VLArrayMemberFind(VLArray *VLA, int Position, void *Key);
//====================================================================================================================
// [@\] VLAɓo^ꂽFind֐KeyL[ƂāAϒz񒆂Position猟A
//        ŏɌoւ̃|C^ԂB
//        ɎsAȂNULLԂ
// [] VLArray       *VLA       F*Objecti[ϒz
// [] int             Position  FJnʒu
// [] void            *Key      FL[ւ̃|C^
// [Ԓl] sNULL

//====================================================================================================================
void *VLArrayMemberGet(VLArray *VLA,  int Position);
//====================================================================================================================
// [@\] ϒz̐擪PositonԖڂ̃oւ̃|C^Ԃ
// [] VLArray *VLA     Fϒz
// [] int       PositionFʒui擪 : Position == 0)
// [Ԓl] sNULL

//====================================================================================================================
int VLArrayConnect(VLArray *LVA0,  VLArray *LVA1);
//====================================================================================================================
// [@\] LVA0LVA1A(LVA1̃wb_͏Ă̂܂܎ĉŃwb_񂻂̂̂KvΕʓr邱Ɓj
// [] VLArray *LVA0 Fϒz
// [] VLArray *LVA1 Fϒz
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB
//====================================================================================================================
int VLArraySwap(VLArray *VLA, int Position0, int Position1);
//====================================================================================================================
// [@\] Position0ObjectPosition1Objectւ
// [] VLArray *VLAFϒz
// [] int *Position0 FΏۃoʒu
// [] int *Position1 FΏۃoʒu
// [Ԓl] sVL_ARRAY_NGAAVL_ARRAY_OKԂB
//====================================================================================================================
int VLArrayNumOfMemberGet(VLArray *Ld);
//====================================================================================================================
// [@\] ݂̗vfԂ
// [] VLArray *VLAFϒz
// [Ԓl] sVL_ARRAY_NGAA0ȏ̒lԂB

#endif // __VL_ARRAY_H__
