﻿//=======================================================================
//  TARGET PROJECT: PSM3(Prosessor Study Model3)
//  FUNCTION      : Debugger
//
//                      Copyright (C) 2008 by Tomoyuki Inomoto
//=======================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Psm3Debugger
{
    public partial class MemAdrSetForm : Form
    {
        public uint ChangeFlag;
        public uint ComboBoxEnableFlag;

        public MemAdrSetForm()
        {
            InitializeComponent();
            ChangeFlag = 0;
            ComboBoxEnableFlag = 0;
        }

        //================================================================================================
        //=　OKボタン
        //================================================================================================
        private void OkBtn_Click(object sender, EventArgs e)
        {
            this.Hide();
            this.ChangeFlag = 1;
        }
        //================================================================================================
        //=　CANSELボタン
        //================================================================================================
        private void CancelBtn_Click(object sender, EventArgs e)
        {
            this.Hide();      
        }
        //================================================================================================
        //=　フォームが閉じないようにする。
        //================================================================================================
        private void MemAdrSetForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.Hide();
            e.Cancel = true;
        }

        private void RadioButton0_CheckedChanged(object sender, EventArgs e)
        {
            if (RadioButton0.Checked == true) TextBox.Enabled = true;
            else TextBox.Enabled = false;
        }

        private void RadioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (RadioButton1.Checked == true)
            {
                if (ComboBoxEnableFlag == 1) ComboBox.Enabled = true;
                else ComboBox.Enabled = false;
            }
            else ComboBox.Enabled = false;
        }

    }
}
