//=======================================================================
//  TARGET PROJECT: PSM3D(Prosessor Study Model3 DualCore)
//  TARGET SYSTEM : DEMO on Sp3StarterKit (PSM3D TARGET SYSTEM)
//  FUNCTION      : vZbTOC[`
//
//                      Copyright (C) 2010 by Tomoyuki Inomoto
//=======================================================================
#include    "Psm3dSys.h"
#include    "DisplaySys.h"

//============================================================================================================
//============================================================================================================
//  EXTERN
//============================================================================================================
//============================================================================================================
void    EnaIrq(void);
void    DisIrq(void);

//============================================================================================================
//============================================================================================================
//  GLOBAL
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  PRIVATE
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  PROTOTYPE
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  BODY
//============================================================================================================
//============================================================================================================
//============================================================================================================
void P0Main(void)
//============================================================================================================
// [@\] vZbT0C[`
// [] 
// [Ԓl]
{
    int   Counter;
    int   P0TimerIrqFlag;
    
    DispInitial();


    //݃Rg[
    *(unsigned long *)REG_IRQ0_CREAR = 0;
    *(unsigned long *)REG_IRQ0_CREAR = 1;
    *(unsigned long *)REG_IRQ0_CREAR = 2;
    *(unsigned long *)REG_IRQ0_CREAR = 3;
    *(unsigned long *)REG_IRQ0_CREAR = 4;
    *(unsigned long *)REG_IRQ0_CREAR = 5;
    *(unsigned long *)REG_IRQ0_MASK = 0x3F;//Srbg}XN
    *(unsigned long *)REG_IRQ0_MASK &= ~BIT_IRQ_TIMER0;//^C}݂̂݋

    //^C}
    *(unsigned long *)REG_TM0_PERIOD = 10000; // 10mS
    *(unsigned long *)REG_TM0_CTRL = BIT_TM_RUN; // ^C}X^[g
    

    EnaIrq();

    Counter = 0;

    while(1){
        P0TimerIrqFlag = *(int *)OCM_BASE_ADR;
        if(P0TimerIrqFlag){
            *(int *)OCM_BASE_ADR = 0;
            ++Counter;
            if(Counter == 10){//0.1b
                Counter = 0;
                DispPutStr("Hello,World!  ");
            }
        }
    }
}
