//=======================================================================
//  TARGET PROJECT: PSM3D(Prosessor Study Model3 DualCore)
//  TARGET SYSTEM : DEMO on Sp3StarterKit (PSM3D TARGET SYSTEM)
//  FUNCTION      : BUS LOCK / ENA_IRQ
//
//                      Copyright (C) 2010 by Tomoyuki Inomoto
//=======================================================================
.FUNCTION BusLock
.CODE
BusLock:    nop
            blk                             // oXbNivZbT̃f[^oXANZXubNj
            nop
Loop0:      movr,   r0,  sr
            andi,   r0, r0, 0x80
            jpi,    eq, PcOffsetOf(Loop0)
            nop
            rts,    al
.ENDFUNCTION

.FUNCTION BusUnLock
.CODE
BusUnLock:  nop
            bulk                                   // oXbN
            nop
Loop0:      movr,   r0, sr
            andi,   r0, r0, 0x80
            jpi,    ne, PcOffsetOf(Loop0)
            nop
            rts,    al
.ENDFUNCTION

.FUNCTION EnaIrq
.CODE
EnaIrq:     ei
            rts,    al
.ENDFUNCTION

.FUNCTION DisIrq
.CODE
DisIrq:     di
            rts,    al
.ENDFUNCTION
