//============================================================
//  TARGET SYSTEM : Psm3Core (Processor Study Model 3 Core)
//  FUNCTION      : Psm3 C Compiler (gbvW[)
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>

#include    "p3cc.h"



//=========================================================
//  GLOBAL
//=========================================================
char    SrcFileName[MAX_SOURCE_FILE_NAME_CHAR];
FILE    *MsgOut;
int     SmallMemory;

//=========================================================
//  PROTOTYPE
//=========================================================
static int  p3cc(char *SourceFile);
static int  CutFileName(char *In, char *Out);

//=========================================================
// [@\] g\
// [] Ȃ
// [Ԓl] Ȃ
//=========================================================
void    PrintHelp(void)
{
    printf("g\n");
    printf("p3cc.exe [-s] ̓t@C(t@C̎ws)\n");
    printf("-stƁAÓIϐ̗̈32KoCgȉɐ񂳂ɁA኱Ȃ\n");
    printf("-sȗƁAÓIϐ̗̈̐񂪂ȂɁA኱xȂ\n");
    printf("     -stꍇ́ARpC邷ׂẴ\[X-swŃRpCA\n");
    printf("       JAZuł-stKv\n");

}

//=========================================================
// [@\] main
// []
// [Ԓl]
//=========================================================
int  main(int argc, char *argv[])
{
    int     Ret;
    printf("PSM3Dp @\CRpC %d.%d.%d  Copyright (C) 2009 mototom\n", VERSION_MAJOR, VERSION_MINER, VERSION_SUB_MINER);
    if((argc < 2) || (argc > 3)){
        PrintHelp();
        return 0;
    }
    if(argc == 3){
        if(strcmp(argv[1], "-s") != 0){
            PrintHelp();
            return 0;
        }
        SmallMemory = P3CC_TRUE;
        printf(" -sIvVw肳܂BÓIϐ̃g[^TCY32KoCgɐ񂳂܂B\n");
        printf(" ܂A{\[XƃN邷ׂẴt@ĆA-swŃRpCKvA\n");
        printf(" NA-sIvVw肷Kv܂B\n");
        CutFileName(argv[2], SrcFileName);
        Ret = p3cc(argv[2]);
    }
    else{
        SmallMemory = P3CC_FALSE;
        CutFileName(argv[1], SrcFileName);
        Ret = p3cc(argv[1]);
    }
    return Ret;
}

//=========================================================
// [@\] RpC{
// [] \[Xt@C
// [Ԓl] P3CC_OKԂB
//=========================================================
static int  p3cc(char *SourceFile)
{
    int                 Ret;
    cc0_result          Cc0Res;         // vvZbTʊi[p\
    cc1_result          Cc1Res;         // ͌ʊi[p\

    MsgOut = stdout;

    //======== vvZbT ==========================
#ifdef CC_MSGENABLE
    printf("\nvvZbT \n");
#endif

    // vvZbTs
    Ret = p3cc0(SourceFile, &Cc0Res);
    if(Ret == P3CC_NG){
        printf("vvZbT A{[g\n");
        return Ret;
    }


    //========  ================================
#ifdef CC_MSGENABLE
    printf("\n\n");
#endif
    // ͎s
    Ret = p3cc1(&Cc0Res, &Cc1Res);
    if(Ret == P3CC_NG){
        printf(" A{[g\n");
        return Ret;
    }

    //======== \́Ӗ́R[h ==========
#ifdef CC_MSGENABLE
    printf("\n\́Ӗ́R[h\n");
#endif
    Ret = p3cc2(&Cc0Res, &Cc1Res);
    if(Ret == P3CC_NG){
        printf("\ A{[g\n");
        return Ret;
    }

    return Ret;
}

//===============================================================
//= t@C̊gqȌJbg
//===============================================================
static int CutFileName(char *In, char *Out)
{
    while(*In != '\0'){
        *Out = *In;
        ++Out, ++In;
        if(*In == '.') break;
    }
    *Out = '\0';
    return P3CC_OK;
}
